# Service account to run elastic search.
apiVersion: v1
kind: ServiceAccount
metadata:
  name: jobsearch
---
# Service to expose and load balance between pods.
apiVersion: v1
kind: Service
metadata:
  name: jobsearch
spec:
  selector:
    app: jobsearch
  ports:
    - protocol: TCP
      port: 80
      targetPort: 8081
---
# Deployment to create necessary pods with configurations.
apiVersion: apps/v1
kind: Deployment
metadata:
  name: jobsearch
  labels:
    app: jobsearch
spec:
  revisionHistoryLimit: 10
  progressDeadlineSeconds: 1200
  strategy:
    type: RollingUpdate
    rollingUpdate:
      maxSurge: 1
      maxUnavailable: 0
  selector:
    matchLabels:
      app: jobsearch
  template:
    metadata:
      labels:
        app: jobsearch
    spec:
      # Pod to launch the service.
      serviceAccountName: jobsearch
      securityContext:
        runAsNonRoot: true
      affinity:
        podAntiAffinity:
          preferredDuringSchedulingIgnoredDuringExecution:
            - weight: 1
              podAffinityTerm:
                labelSelector:
                  matchLabels:
                    app: jobsearch
                topologyKey: kubernetes.io/hostname
      containers:
        - name: jobsearch
          image: docker-images.jobtechdev.se/jobsearch-api/jobsearch-api:latest
          imagePullPolicy: IfNotPresent
          envFrom:
            - configMapRef:
                name: jobsearch
            - secretRef:
                name: db-account-api
          ports:
            - containerPort: 8081
          readinessProbe:
            initialDelaySeconds: 30
            timeoutSeconds: 5
            periodSeconds: 20
            successThreshold: 1
            failureThreshold: 3
            httpGet:
              path: /swagger.json
              port: 8081
          livenessProbe:
            initialDelaySeconds: 30
            timeoutSeconds: 5
            periodSeconds: 20
            httpGet:
              path: /search?region=01&limit=0
              port: 8081
            successThreshold: 1
            failureThreshold: 3
          securityContext:
            readOnlyRootFilesystem: true
            allowPrivilegeEscalation: false
          resources:
            requests:
              cpu: "1"
              memory: "2Gi"
